import java.net.*;
import java.io.*;


public class PortScanner {

  public static void main(String[] args) {
    
    String host = "localhost";

    if (args.length > 0) {
      host = args[0];
    }

    Socket connection = null;
    try {
      InetAddress theAddress = InetAddress.getByName(host);
      for (int i = 1; i < 65536; i++) {
        try {
          connection = new Socket(host, i);
          System.out.println("There is a server on port " 
           + i + " of " + host);
        }
        catch (IOException e) {
          // must not be a server on this port
        }
      } // end for
    } // end try
    catch (UnknownHostException e) {
      System.err.println(e);
    }
    finally {
      try {
        if (connection != null) connection.close(); 
      }
      catch (IOException e) {}
    }
    
  }  // end main
  
}  // end PortScanner
